// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "marine_sensor_msgs/msg/detail/radar_sector__functions.h"
#include "marine_sensor_msgs/msg/detail/radar_sector__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace marine_sensor_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void RadarSector_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) marine_sensor_msgs::msg::RadarSector(_init);
}

void RadarSector_fini_function(void * message_memory)
{
  auto typed_message = static_cast<marine_sensor_msgs::msg::RadarSector *>(message_memory);
  typed_message->~RadarSector();
}

size_t size_function__RadarSector__intensities(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<marine_sensor_msgs::msg::RadarEcho> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RadarSector__intensities(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<marine_sensor_msgs::msg::RadarEcho> *>(untyped_member);
  return &member[index];
}

void * get_function__RadarSector__intensities(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<marine_sensor_msgs::msg::RadarEcho> *>(untyped_member);
  return &member[index];
}

void fetch_function__RadarSector__intensities(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const marine_sensor_msgs::msg::RadarEcho *>(
    get_const_function__RadarSector__intensities(untyped_member, index));
  auto & value = *reinterpret_cast<marine_sensor_msgs::msg::RadarEcho *>(untyped_value);
  value = item;
}

void assign_function__RadarSector__intensities(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<marine_sensor_msgs::msg::RadarEcho *>(
    get_function__RadarSector__intensities(untyped_member, index));
  const auto & value = *reinterpret_cast<const marine_sensor_msgs::msg::RadarEcho *>(untyped_value);
  item = value;
}

void resize_function__RadarSector__intensities(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<marine_sensor_msgs::msg::RadarEcho> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RadarSector_message_member_array[8] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "angle_start",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, angle_start),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "angle_increment",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, angle_increment),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "time_increment",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<builtin_interfaces::msg::Duration>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, time_increment),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "scan_time",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<builtin_interfaces::msg::Duration>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, scan_time),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "range_min",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, range_min),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "range_max",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, range_max),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "intensities",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<marine_sensor_msgs::msg::RadarEcho>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarSector, intensities),  // bytes offset in struct
    nullptr,  // default value
    size_function__RadarSector__intensities,  // size() function pointer
    get_const_function__RadarSector__intensities,  // get_const(index) function pointer
    get_function__RadarSector__intensities,  // get(index) function pointer
    fetch_function__RadarSector__intensities,  // fetch(index, &value) function pointer
    assign_function__RadarSector__intensities,  // assign(index, value) function pointer
    resize_function__RadarSector__intensities  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RadarSector_message_members = {
  "marine_sensor_msgs::msg",  // message namespace
  "RadarSector",  // message name
  8,  // number of fields
  sizeof(marine_sensor_msgs::msg::RadarSector),
  false,  // has_any_key_member_
  RadarSector_message_member_array,  // message members
  RadarSector_init_function,  // function to initialize message memory (memory has to be allocated)
  RadarSector_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RadarSector_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RadarSector_message_members,
  get_message_typesupport_handle_function,
  &marine_sensor_msgs__msg__RadarSector__get_type_hash,
  &marine_sensor_msgs__msg__RadarSector__get_type_description,
  &marine_sensor_msgs__msg__RadarSector__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace marine_sensor_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<marine_sensor_msgs::msg::RadarSector>()
{
  return &::marine_sensor_msgs::msg::rosidl_typesupport_introspection_cpp::RadarSector_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, marine_sensor_msgs, msg, RadarSector)() {
  return &::marine_sensor_msgs::msg::rosidl_typesupport_introspection_cpp::RadarSector_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
